import { __decorate, __param } from 'vscode/external/tslib/tslib.es6.js';
import { $ as $$1, h, append, addStandardDisposableListener, EventType, clearNode, setVisibility, addDisposableListener, EventHelper, isKeyboardEvent, Dimension, getTotalWidth, reset } from 'vscode/vscode/vs/base/browser/dom';
import { DEFAULT_FONT_FAMILY } from 'vscode/vscode/vs/base/browser/fonts';
import { StandardKeyboardEvent } from 'vscode/vscode/vs/base/browser/keyboardEvent';
import { status } from 'vscode/vscode/vs/base/browser/ui/aria/aria';
import { Button } from 'vscode/vscode/vs/base/browser/ui/button/button';
import { createInstantHoverDelegate } from 'vscode/vscode/vs/base/browser/ui/hover/hoverDelegateFactory';
import { renderLabelWithIcons } from 'vscode/vscode/vs/base/browser/ui/iconLabel/iconLabels';
import { ProgressBar } from 'vscode/vscode/vs/base/browser/ui/progressbar/progressbar';
import { coalesce } from 'vscode/vscode/vs/base/common/arrays';
import { Promises } from 'vscode/vscode/vs/base/common/async';
import { Codicon } from 'vscode/vscode/vs/base/common/codicons';
import { Emitter, Event } from 'vscode/vscode/vs/base/common/event';
import { HistoryNavigator2 } from 'vscode/vscode/vs/base/common/history';
import { Disposable, DisposableStore, MutableDisposable } from 'vscode/vscode/vs/base/common/lifecycle';
import { ResourceSet } from 'vscode/vscode/vs/base/common/map';
import { basename, dirname } from 'vscode/vscode/vs/base/common/path';
import { isMacintosh } from 'vscode/vscode/vs/base/common/platform';
import { URI } from 'vscode/vscode/vs/base/common/uri';
import { EditorExtensionsRegistry } from 'vscode/vscode/vs/editor/browser/editorExtensions';
import { CodeEditorWidget } from 'vscode/vscode/vs/editor/browser/widget/codeEditor/codeEditorWidget';
import { EditorOptions } from 'vscode/vscode/vs/editor/common/config/editorOptions';
import { Range } from 'vscode/vscode/vs/editor/common/core/range';
import { IModelService } from 'vscode/vscode/vs/editor/common/services/model';
import { CopyPasteController } from 'vscode/vscode/vs/editor/contrib/dropOrPasteInto/browser/copyPasteController';
import { ContentHoverController } from 'vscode/vscode/vs/editor/contrib/hover/browser/contentHoverController';
import { GlyphHoverController } from 'vscode/vscode/vs/editor/contrib/hover/browser/glyphHoverController';
import { SuggestController } from 'vscode/vscode/vs/editor/contrib/suggest/browser/suggestController';
import { localize } from 'vscode/vscode/vs/nls';
import { IAccessibilityService } from 'vscode/vscode/vs/platform/accessibility/common/accessibility.service';
import { MenuWorkbenchButtonBar } from '@codingame/monaco-vscode-chat-extensions-interactive-notebook-search-terminal-common/vscode/vs/platform/actions/browser/buttonbar';
import { DropdownWithPrimaryActionViewItem } from 'vscode/vscode/vs/platform/actions/browser/dropdownWithPrimaryActionViewItem';
import { createAndFillInActionBarActions, MenuEntryActionViewItem } from 'vscode/vscode/vs/platform/actions/browser/menuEntryActionViewItem';
import { MenuWorkbenchToolBar } from 'vscode/vscode/vs/platform/actions/browser/toolbar';
import { MenuId, MenuItemAction } from 'vscode/vscode/vs/platform/actions/common/actions';
import { IMenuService } from 'vscode/vscode/vs/platform/actions/common/actions.service';
import { ICommandService } from 'vscode/vscode/vs/platform/commands/common/commands.service';
import { IConfigurationService } from 'vscode/vscode/vs/platform/configuration/common/configuration.service';
import { IContextKeyService } from 'vscode/vscode/vs/platform/contextkey/common/contextkey.service';
import { IContextMenuService } from 'vscode/vscode/vs/platform/contextview/browser/contextView.service';
import { FileKind } from 'vscode/vscode/vs/platform/files/common/files';
import { IFileService } from 'vscode/vscode/vs/platform/files/common/files.service';
import { registerAndCreateHistoryNavigationContext } from 'vscode/vscode/vs/platform/history/browser/contextScopedHistoryWidget';
import { IHoverService } from 'vscode/vscode/vs/platform/hover/browser/hover.service';
import { IInstantiationService } from 'vscode/vscode/vs/platform/instantiation/common/instantiation';
import { ServiceCollection } from 'vscode/vscode/vs/platform/instantiation/common/serviceCollection';
import { IKeybindingService } from 'vscode/vscode/vs/platform/keybinding/common/keybinding.service';
import { ILogService } from 'vscode/vscode/vs/platform/log/common/log.service';
import { INotificationService } from 'vscode/vscode/vs/platform/notification/common/notification.service';
import { IOpenerService } from 'vscode/vscode/vs/platform/opener/common/opener.service';
import { IThemeService } from 'vscode/vscode/vs/platform/theme/common/themeService.service';
import { ResourceLabels } from 'vscode/vscode/vs/workbench/browser/labels';
import { SIDE_GROUP, ACTIVE_GROUP } from 'vscode/vscode/vs/workbench/services/editor/common/editorService';
import { IEditorService } from 'vscode/vscode/vs/workbench/services/editor/common/editorService.service';
import { getSimpleEditorOptions, getSimpleCodeEditorWidgetOptions, setupSimpleEditorSelectionStyling } from 'vscode/vscode/vs/workbench/contrib/codeEditor/browser/simpleEditorOptions';
import { ChatAgentLocation } from 'vscode/vscode/vs/workbench/contrib/chat/common/chatAgents';
import { IChatAgentService } from 'vscode/vscode/vs/workbench/contrib/chat/common/chatAgents.service';
import { CONTEXT_CHAT_INPUT_HAS_TEXT, CONTEXT_CHAT_INPUT_CURSOR_AT_TOP, CONTEXT_CHAT_INPUT_HAS_FOCUS, CONTEXT_CHAT_HAS_FILE_ATTACHMENTS, CONTEXT_IN_CHAT_INPUT } from 'vscode/vscode/vs/workbench/contrib/chat/common/chatContextKeys';
import { IChatEditingService } from 'vscode/vscode/vs/workbench/contrib/chat/common/chatEditingService.service';
import { IChatWidgetHistoryService } from 'vscode/vscode/vs/workbench/contrib/chat/common/chatWidgetHistoryService.service';
import { ILanguageModelsService } from 'vscode/vscode/vs/workbench/contrib/chat/common/languageModels.service';
import { SubmitAction, CancelAction, ChatModelPickerActionId, ChatSubmitSecondaryAgentAction } from './actions/chatExecuteActions.js';
import { ImplicitContextAttachmentWidget } from './attachments/implicitContextAttachment.js';
import { ChatAttachmentModel } from './chatAttachmentModel.js';
import { CollapsibleListPool } from '@codingame/monaco-vscode-chat-extensions-interactive-notebook-search-terminal-common/vscode/vs/workbench/contrib/chat/browser/chatContentParts/chatReferencesContentPart';
import { ChatEditingShowChangesAction } from './chatEditing/chatEditingActions.js';
import { ChatEditingSaveAllAction } from './chatEditorSaving.js';
import { ChatFollowups } from './chatFollowups.js';
import { ChatImplicitContext } from './contrib/chatImplicitContext.js';

var ChatInputPart_1;
const $ = $$1;
const INPUT_EDITOR_MAX_HEIGHT = 250;
let ChatInputPart = class ChatInputPart extends Disposable {
    static { ChatInputPart_1 = this; }
    static { this.INPUT_SCHEME = 'chatSessionInput'; }
    static { this._counter = 0; }
    get attachmentModel() {
        return this._attachmentModel;
    }
    getAttachedAndImplicitContext() {
        const contextArr = [...this.attachmentModel.attachments];
        if (this.implicitContext?.enabled && this.implicitContext.value) {
            contextArr.push(this.implicitContext.toBaseEntry());
        }
        return contextArr;
    }
    get implicitContext() {
        return this._implicitContext;
    }
    get inputPartHeight() {
        return this._inputPartHeight;
    }
    get followupsHeight() {
        return this._followupsHeight;
    }
    get inputEditor() {
        return this._inputEditor;
    }
    get currentLanguageModel() {
        return this._currentLanguageModel;
    }
    get selectedElements() {
        const edits = [];
        const editsList = this._chatEditList?.object;
        const selectedElements = editsList?.getSelectedElements() ?? [];
        for (const element of selectedElements) {
            if (element.kind === 'reference' && URI.isUri(element.reference)) {
                edits.push(element.reference);
            }
        }
        return edits;
    }
    get chatEditWorkingSetFiles() {
        return this._combinedChatEditWorkingSetEntries;
    }
    constructor(
    location, options, getContribsInputState, historyService, modelService, instantiationService, contextKeyService, configurationService, keybindingService, accessibilityService, languageModelsService, logService, hoverService, fileService, commandService, editorService, openerService, chatEditingService) {
        super();
        this.location = location;
        this.options = options;
        this.historyService = historyService;
        this.modelService = modelService;
        this.instantiationService = instantiationService;
        this.contextKeyService = contextKeyService;
        this.configurationService = configurationService;
        this.keybindingService = keybindingService;
        this.accessibilityService = accessibilityService;
        this.languageModelsService = languageModelsService;
        this.logService = logService;
        this.hoverService = hoverService;
        this.fileService = fileService;
        this.commandService = commandService;
        this.editorService = editorService;
        this.openerService = openerService;
        this.chatEditingService = chatEditingService;
        this._onDidLoadInputState = this._register(( (new Emitter())));
        this.onDidLoadInputState = this._onDidLoadInputState.event;
        this._onDidChangeHeight = this._register(( (new Emitter())));
        this.onDidChangeHeight = this._onDidChangeHeight.event;
        this._onDidFocus = this._register(( (new Emitter())));
        this.onDidFocus = this._onDidFocus.event;
        this._onDidBlur = this._register(( (new Emitter())));
        this.onDidBlur = this._onDidBlur.event;
        this._onDidChangeContext = this._register(( (new Emitter())));
        this.onDidChangeContext = this._onDidChangeContext.event;
        this._onDidAcceptFollowup = this._register(( (new Emitter())));
        this.onDidAcceptFollowup = this._onDidAcceptFollowup.event;
        this._indexOfLastAttachedContextDeletedWithKeyboard = -1;
        this._onDidChangeVisibility = this._register(( (new Emitter())));
        this._contextResourceLabels = this.instantiationService.createInstance(ResourceLabels, { onDidChangeVisibility: this._onDidChangeVisibility.event });
        this.inputEditorHeight = 0;
        this.followupsDisposables = this._register(( (new DisposableStore())));
        this.attachedContextDisposables = this._register(( (new MutableDisposable())));
        this._inputPartHeight = 0;
        this._followupsHeight = 0;
        this._waitForPersistedLanguageModel = this._register(( (new MutableDisposable())));
        this._onDidChangeCurrentLanguageModel = ( (new Emitter()));
        this.inputUri = ( (URI.parse(`${ChatInputPart_1.INPUT_SCHEME}:input-${ChatInputPart_1._counter++}`)));
        this._chatEditsActionsDisposables = this._register(( (new DisposableStore())));
        this._chatEditsDisposables = this._register(( (new DisposableStore())));
        this._combinedChatEditWorkingSetEntries = [];
        this._attachmentModel = this._register(( (new ChatAttachmentModel())));
        this.getInputState = () => {
            return {
                ...getContribsInputState(),
                chatContextAttachments: this._attachmentModel.attachments,
            };
        };
        this.inputEditorMaxHeight = this.options.renderStyle === 'compact' ? INPUT_EDITOR_MAX_HEIGHT / 3 : INPUT_EDITOR_MAX_HEIGHT;
        this.inputEditorHasText = CONTEXT_CHAT_INPUT_HAS_TEXT.bindTo(contextKeyService);
        this.chatCursorAtTop = CONTEXT_CHAT_INPUT_CURSOR_AT_TOP.bindTo(contextKeyService);
        this.inputEditorHasFocus = CONTEXT_CHAT_INPUT_HAS_FOCUS.bindTo(contextKeyService);
        this.history = this.loadHistory();
        this._register(this.historyService.onDidClearHistory(() => this.history = ( (new HistoryNavigator2([{ text: '' }], 50, historyKeyFn)))));
        this._register(this.configurationService.onDidChangeConfiguration(e => {
            if (e.affectsConfiguration("accessibility.verbosity.panelChat" )) {
                this.inputEditor.updateOptions({ ariaLabel: this._getAriaLabel() });
            }
        }));
        this._chatEditsListPool = this._register(this.instantiationService.createInstance(CollapsibleListPool, this._onDidChangeVisibility.event, MenuId.ChatEditingWidgetModifiedFilesToolbar));
        this._hasFileAttachmentContextKey = CONTEXT_CHAT_HAS_FILE_ATTACHMENTS.bindTo(contextKeyService);
    }
    setCurrentLanguageModelToDefault() {
        const defaultLanguageModel = this.languageModelsService.getLanguageModelIds().find(id => this.languageModelsService.lookupLanguageModel(id)?.isDefault);
        const hasUserSelectableLanguageModels = this.languageModelsService.getLanguageModelIds().find(id => {
            const model = this.languageModelsService.lookupLanguageModel(id);
            return model?.isUserSelectable && !model.isDefault;
        });
        this._currentLanguageModel = hasUserSelectableLanguageModels ? defaultLanguageModel : undefined;
    }
    setCurrentLanguageModelByUser(modelId) {
        this._currentLanguageModel = modelId;
        this._waitForPersistedLanguageModel.clear();
        if (this.cachedDimensions) {
            this.layout(this.cachedDimensions.height, this.cachedDimensions.width);
        }
    }
    loadHistory() {
        const history = this.historyService.getHistory(this.location);
        if (history.length === 0) {
            history.push({ text: '' });
        }
        return (
             (new HistoryNavigator2(history, 50, historyKeyFn))
        );
    }
    _getAriaLabel() {
        const verbose = this.configurationService.getValue("accessibility.verbosity.panelChat" );
        if (verbose) {
            const kbLabel = this.keybindingService.lookupKeybinding("editor.action.accessibilityHelp" )?.getLabel();
            return kbLabel ? ( localize(
                7372,
                "Chat Input,  Type to ask questions or type / for topics, press enter to send out the request. Use {0} for Chat Accessibility Help.",
                kbLabel
            )) : ( localize(
                7373,
                "Chat Input,  Type code here and press Enter to run. Use the Chat Accessibility Help command for more information."
            ));
        }
        return ( localize(7374, "Chat Input"));
    }
    initForNewChatModel(state) {
        this.history = this.loadHistory();
        this.history.add({
            text: state.inputValue ?? this.history.current().text,
            state: state.inputState ?? this.getInputState()
        });
        const attachments = state.inputState?.chatContextAttachments ?? [];
        this._attachmentModel.clearAndSetContext(...attachments);
        if (state.inputValue) {
            this.setValue(state.inputValue, false);
        }
        if (state.selectedLanguageModelId) {
            const model = this.languageModelsService.lookupLanguageModel(state.selectedLanguageModelId);
            if (model) {
                this._currentLanguageModel = state.selectedLanguageModelId;
                this._onDidChangeCurrentLanguageModel.fire(this._currentLanguageModel);
            }
            else {
                this._waitForPersistedLanguageModel.value = this.languageModelsService.onDidChangeLanguageModels(e => {
                    const persistedModel = e.added?.find(m => m.identifier === state.selectedLanguageModelId);
                    if (persistedModel) {
                        this._waitForPersistedLanguageModel.clear();
                        if (persistedModel.metadata.isUserSelectable) {
                            this._currentLanguageModel = state.selectedLanguageModelId;
                            this._onDidChangeCurrentLanguageModel.fire(this._currentLanguageModel);
                        }
                    }
                });
            }
        }
    }
    logInputHistory() {
        const historyStr = ( ([...this.history].map(entry => JSON.stringify(entry)))).join('\n');
        this.logService.info(`[${this.location}] Chat input history:`, historyStr);
    }
    setVisible(visible) {
        this._onDidChangeVisibility.fire(visible);
    }
    get element() {
        return this.container;
    }
    showPreviousValue() {
        const inputState = this.getInputState();
        if (this.history.isAtEnd()) {
            this.saveCurrentValue(inputState);
        }
        else {
            if (!( (this.history.has({ text: this._inputEditor.getValue(), state: inputState })))) {
                this.saveCurrentValue(inputState);
                this.history.resetCursor();
            }
        }
        this.navigateHistory(true);
    }
    showNextValue() {
        const inputState = this.getInputState();
        if (this.history.isAtEnd()) {
            return;
        }
        else {
            if (!( (this.history.has({ text: this._inputEditor.getValue(), state: inputState })))) {
                this.saveCurrentValue(inputState);
                this.history.resetCursor();
            }
        }
        this.navigateHistory(false);
    }
    navigateHistory(previous) {
        const historyEntry = previous ?
            this.history.previous() : this.history.next();
        const historyAttachments = historyEntry.state?.chatContextAttachments ?? [];
        this._attachmentModel.clearAndSetContext(...historyAttachments);
        status(historyEntry.text);
        this.setValue(historyEntry.text, true);
        this._onDidLoadInputState.fire(historyEntry.state);
        const model = this._inputEditor.getModel();
        if (!model) {
            return;
        }
        if (previous) {
            const endOfFirstViewLine = this._inputEditor._getViewModel()?.getLineLength(1) ?? 1;
            const endOfFirstModelLine = model.getLineLength(1);
            if (endOfFirstViewLine === endOfFirstModelLine) {
                this._inputEditor.setPosition({ lineNumber: 1, column: endOfFirstViewLine + 1 });
            }
            else {
                this._inputEditor.setPosition({ lineNumber: 1, column: endOfFirstViewLine });
            }
        }
        else {
            this._inputEditor.setPosition(getLastPosition(model));
        }
    }
    setValue(value, transient) {
        this.inputEditor.setValue(value);
        this.inputEditor.setPosition({ lineNumber: 1, column: value.length + 1 });
        if (!transient) {
            this.saveCurrentValue(this.getInputState());
        }
    }
    saveCurrentValue(inputState) {
        const newEntry = { text: this._inputEditor.getValue(), state: inputState };
        this.history.replaceLast(newEntry);
    }
    focus() {
        this._inputEditor.focus();
    }
    hasFocus() {
        return this._inputEditor.hasWidgetFocus();
    }
    async acceptInput(isUserQuery) {
        if (isUserQuery) {
            const userQuery = this._inputEditor.getValue();
            const entry = { text: userQuery, state: this.getInputState() };
            this.history.replaceLast(entry);
            this.history.add({ text: '' });
        }
        this.attachmentModel.clear();
        this._onDidLoadInputState.fire({});
        if (this.accessibilityService.isScreenReaderOptimized() && isMacintosh) {
            this._acceptInputForVoiceover();
        }
        else {
            this._inputEditor.focus();
            this._inputEditor.setValue('');
        }
    }
    _acceptInputForVoiceover() {
        const domNode = this._inputEditor.getDomNode();
        if (!domNode) {
            return;
        }
        domNode.remove();
        this._inputEditor.setValue('');
        this._inputEditorElement.appendChild(domNode);
        this._inputEditor.focus();
    }
    _handleAttachedContextChange() {
        this._hasFileAttachmentContextKey.set(Boolean(this._attachmentModel.attachments.find(a => a.isFile)));
        this.renderAttachedContext();
    }
    render(container, initialValue, widget) {
        let elements;
        if (this.options.renderStyle === 'compact') {
            elements = h('.interactive-input-part', [
                h('.interactive-input-and-edit-session', [
                    h('.chat-editing-session@chatEditingSessionWidgetContainer'),
                    h('.interactive-input-and-side-toolbar@inputAndSideToolbar', [
                        h('.chat-input-container@inputContainer', [
                            h('.chat-editor-container@editorContainer'),
                            h('.chat-input-toolbars@inputToolbars'),
                        ]),
                    ]),
                    h('.chat-attached-context@attachedContextContainer'),
                    h('.interactive-input-followups@followupsContainer'),
                ])
            ]);
        }
        else {
            elements = h('.interactive-input-part', [
                h('.interactive-input-followups@followupsContainer'),
                h('.chat-editing-session@chatEditingSessionWidgetContainer'),
                h('.interactive-input-and-side-toolbar@inputAndSideToolbar', [
                    h('.chat-input-container@inputContainer', [
                        h('.chat-editor-container@editorContainer'),
                        h('.chat-attached-context@attachedContextContainer'),
                        h('.chat-input-toolbars@inputToolbars'),
                    ]),
                ]),
            ]);
        }
        this.container = elements.root;
        container.append(this.container);
        this.container.classList.toggle('compact', this.options.renderStyle === 'compact');
        this.followupsContainer = elements.followupsContainer;
        const inputAndSideToolbar = elements.inputAndSideToolbar;
        const inputContainer = elements.inputContainer;
        const editorContainer = elements.editorContainer;
        this.attachedContextContainer = elements.attachedContextContainer;
        const toolbarsContainer = elements.inputToolbars;
        this.chatEditingSessionWidgetContainer = elements.chatEditingSessionWidgetContainer;
        this.renderAttachedContext();
        if (this.options.enableImplicitContext) {
            this._implicitContext = this._register(( (new ChatImplicitContext())));
            this._register(this._implicitContext.onDidChangeValue(() => this._handleAttachedContextChange()));
        }
        this._register(this._attachmentModel.onDidChangeContext(() => this._handleAttachedContextChange()));
        this.renderChatEditingSessionState(null, widget);
        const inputScopedContextKeyService = this._register(this.contextKeyService.createScoped(inputContainer));
        CONTEXT_IN_CHAT_INPUT.bindTo(inputScopedContextKeyService).set(true);
        const scopedInstantiationService = this._register(this.instantiationService.createChild(( (new ServiceCollection([IContextKeyService, inputScopedContextKeyService])))));
        const { historyNavigationBackwardsEnablement, historyNavigationForwardsEnablement } = this._register(registerAndCreateHistoryNavigationContext(inputScopedContextKeyService, this));
        this.historyNavigationBackwardsEnablement = historyNavigationBackwardsEnablement;
        this.historyNavigationForewardsEnablement = historyNavigationForwardsEnablement;
        const options = getSimpleEditorOptions(this.configurationService);
        options.overflowWidgetsDomNode = this.options.editorOverflowWidgetsDomNode;
        options.pasteAs = EditorOptions.pasteAs.defaultValue;
        options.readOnly = false;
        options.ariaLabel = this._getAriaLabel();
        options.fontFamily = DEFAULT_FONT_FAMILY;
        options.fontSize = 13;
        options.lineHeight = 20;
        options.padding = this.options.renderStyle === 'compact' ? { top: 2, bottom: 2 } : { top: 8, bottom: 8 };
        options.cursorWidth = 1;
        options.wrappingStrategy = 'advanced';
        options.bracketPairColorization = { enabled: false };
        options.suggest = {
            showIcons: false,
            showSnippets: false,
            showWords: true,
            showStatusBar: false,
            insertMode: 'replace',
        };
        options.scrollbar = { ...(options.scrollbar ?? {}), vertical: 'hidden' };
        options.stickyScroll = { enabled: false };
        this._inputEditorElement = append(editorContainer, $(chatInputEditorContainerSelector));
        const editorOptions = getSimpleCodeEditorWidgetOptions();
        editorOptions.contributions?.push(...EditorExtensionsRegistry.getSomeEditorContributions([ContentHoverController.ID, GlyphHoverController.ID, CopyPasteController.ID]));
        this._inputEditor = this._register(scopedInstantiationService.createInstance(CodeEditorWidget, this._inputEditorElement, options, editorOptions));
        SuggestController.get(this._inputEditor)?.forceRenderingAbove();
        this._register(this._inputEditor.onDidChangeModelContent(() => {
            const currentHeight = Math.min(this._inputEditor.getContentHeight(), this.inputEditorMaxHeight);
            if (currentHeight !== this.inputEditorHeight) {
                this.inputEditorHeight = currentHeight;
                this._onDidChangeHeight.fire();
            }
            const model = this._inputEditor.getModel();
            const inputHasText = !!model && model.getValue().trim().length > 0;
            this.inputEditorHasText.set(inputHasText);
        }));
        this._register(this._inputEditor.onDidFocusEditorText(() => {
            this.inputEditorHasFocus.set(true);
            this._onDidFocus.fire();
            inputContainer.classList.toggle('focused', true);
        }));
        this._register(this._inputEditor.onDidBlurEditorText(() => {
            this.inputEditorHasFocus.set(false);
            inputContainer.classList.toggle('focused', false);
            this._onDidBlur.fire();
        }));
        const hoverDelegate = this._register(createInstantHoverDelegate());
        this._register(addStandardDisposableListener(toolbarsContainer, EventType.CLICK, e => this.inputEditor.focus()));
        this.inputActionsToolbar = this._register(this.instantiationService.createInstance(MenuWorkbenchToolBar, toolbarsContainer, MenuId.ChatInput, {
            telemetrySource: this.options.menus.telemetrySource,
            menuOptions: { shouldForwardArgs: true },
            hiddenItemStrategy: 0 ,
            hoverDelegate
        }));
        this.inputActionsToolbar.context = { widget };
        this._register(this.inputActionsToolbar.onDidChangeMenuItems(() => {
            if (this.cachedDimensions && typeof this.cachedInputToolbarWidth === 'number' && this.cachedInputToolbarWidth !== this.inputActionsToolbar.getItemsWidth()) {
                this.layout(this.cachedDimensions.height, this.cachedDimensions.width);
            }
        }));
        this.executeToolbar = this._register(this.instantiationService.createInstance(MenuWorkbenchToolBar, toolbarsContainer, this.options.menus.executeToolbar, {
            telemetrySource: this.options.menus.telemetrySource,
            menuOptions: {
                shouldForwardArgs: true
            },
            hoverDelegate,
            hiddenItemStrategy: 0 ,
            actionViewItemProvider: (action, options) => {
                if (this.location === ChatAgentLocation.Panel) {
                    if ((action.id === SubmitAction.ID || action.id === CancelAction.ID) && action instanceof MenuItemAction) {
                        const dropdownAction = this.instantiationService.createInstance(MenuItemAction, { id: 'chat.moreExecuteActions', title: ( localize(7375, "More...")), icon: Codicon.chevronDown }, undefined, undefined, undefined, undefined);
                        return this.instantiationService.createInstance(ChatSubmitDropdownActionItem, action, dropdownAction, options);
                    }
                }
                if (action.id === ChatModelPickerActionId && action instanceof MenuItemAction) {
                    if (!this._currentLanguageModel) {
                        this.setCurrentLanguageModelToDefault();
                    }
                    if (this._currentLanguageModel) {
                        const itemDelegate = {
                            onDidChangeModel: this._onDidChangeCurrentLanguageModel.event,
                            setModel: (modelId) => {
                                this.setCurrentLanguageModelByUser(modelId);
                            }
                        };
                        return this.instantiationService.createInstance(ModelPickerActionViewItem, action, this._currentLanguageModel, itemDelegate, { hoverDelegate: options.hoverDelegate, keybinding: options.keybinding ?? undefined });
                    }
                }
                return undefined;
            }
        }));
        this.executeToolbar.getElement().classList.add('chat-execute-toolbar');
        this.executeToolbar.context = { widget };
        this._register(this.executeToolbar.onDidChangeMenuItems(() => {
            if (this.cachedDimensions && typeof this.cachedExecuteToolbarWidth === 'number' && this.cachedExecuteToolbarWidth !== this.executeToolbar.getItemsWidth()) {
                this.layout(this.cachedDimensions.height, this.cachedDimensions.width);
            }
        }));
        if (this.options.menus.inputSideToolbar) {
            const toolbarSide = this._register(this.instantiationService.createInstance(MenuWorkbenchToolBar, inputAndSideToolbar, this.options.menus.inputSideToolbar, {
                telemetrySource: this.options.menus.telemetrySource,
                menuOptions: {
                    shouldForwardArgs: true
                },
                hoverDelegate
            }));
            this.inputSideToolbarContainer = toolbarSide.getElement();
            toolbarSide.getElement().classList.add('chat-side-toolbar');
            toolbarSide.context = { widget };
        }
        let inputModel = this.modelService.getModel(this.inputUri);
        if (!inputModel) {
            inputModel = this.modelService.createModel('', null, this.inputUri, true);
            this._register(inputModel);
        }
        this.inputModel = inputModel;
        this.inputModel.updateOptions({ bracketColorizationOptions: { enabled: false, independentColorPoolPerBracketType: false } });
        this._inputEditor.setModel(this.inputModel);
        if (initialValue) {
            this.inputModel.setValue(initialValue);
            const lineNumber = this.inputModel.getLineCount();
            this._inputEditor.setPosition({ lineNumber, column: this.inputModel.getLineMaxColumn(lineNumber) });
        }
        const onDidChangeCursorPosition = () => {
            const model = this._inputEditor.getModel();
            if (!model) {
                return;
            }
            const position = this._inputEditor.getPosition();
            if (!position) {
                return;
            }
            const atTop = position.lineNumber === 1 && position.column - 1 <= (this._inputEditor._getViewModel()?.getLineLength(1) ?? 0);
            this.chatCursorAtTop.set(atTop);
            this.historyNavigationBackwardsEnablement.set(atTop);
            this.historyNavigationForewardsEnablement.set(position.equals(getLastPosition(model)));
        };
        this._register(this._inputEditor.onDidChangeCursorPosition(e => onDidChangeCursorPosition()));
        onDidChangeCursorPosition();
    }
    async renderAttachedContext() {
        const container = this.attachedContextContainer;
        const oldHeight = container.offsetHeight;
        const store = ( (new DisposableStore()));
        this.attachedContextDisposables.value = store;
        clearNode(container);
        const hoverDelegate = store.add(createInstantHoverDelegate());
        setVisibility(Boolean(this.attachmentModel.size) || Boolean(this.implicitContext?.value), this.attachedContextContainer);
        if (!this.attachmentModel.size) {
            this._indexOfLastAttachedContextDeletedWithKeyboard = -1;
        }
        if (this.implicitContext?.value) {
            const implicitPart = store.add(this.instantiationService.createInstance(ImplicitContextAttachmentWidget, this.implicitContext, this._contextResourceLabels));
            container.appendChild(implicitPart.domNode);
        }
        const attachmentInitPromises = [];
        for (const [index, attachment] of this.attachmentModel.attachments.entries()) {
            if (attachment.isFile && this.location === ChatAgentLocation.EditingSession) {
                return;
            }
            const widget = append(container, $('.chat-attached-context-attachment.show-file-icons'));
            const label = this._contextResourceLabels.create(widget, { supportIcons: true, hoverDelegate, hoverTargetOverrride: widget });
            let ariaLabel;
            const file = URI.isUri(attachment.value) ? attachment.value : attachment.value && typeof attachment.value === 'object' && 'uri' in attachment.value && URI.isUri(attachment.value.uri) ? attachment.value.uri : undefined;
            const range = attachment.value && typeof attachment.value === 'object' && 'range' in attachment.value && Range.isIRange(attachment.value.range) ? attachment.value.range : undefined;
            if (file && attachment.isFile) {
                const fileBasename = basename(file.path);
                const fileDirname = dirname(file.path);
                const friendlyName = `${fileBasename} ${fileDirname}`;
                ariaLabel = range ? ( localize(
                    7376,
                    "Attached file, {0}, line {1} to line {2}",
                    friendlyName,
                    range.startLineNumber,
                    range.endLineNumber
                )) : ( localize(7377, "Attached file, {0}", friendlyName));
                label.setFile(file, {
                    fileKind: FileKind.FILE,
                    hidePath: true,
                    range,
                });
                this.attachButtonAndDisposables(widget, index, attachment, hoverDelegate);
            }
            else if (attachment.isImage) {
                ariaLabel = ( localize(7378, "Attached image, {0}", attachment.name));
                const hoverElement = $$1('div.chat-attached-context-hover');
                hoverElement.setAttribute('aria-label', ariaLabel);
                const pillIcon = $$1('div.chat-attached-context-pill', {}, $$1('span.codicon.codicon-file-media'));
                const textLabel = $$1('span.chat-attached-context-custom-text', {}, attachment.name);
                widget.appendChild(pillIcon);
                widget.appendChild(textLabel);
                attachmentInitPromises.push(Promises.withAsyncBody(async (resolve) => {
                    let buffer;
                    try {
                        this.attachButtonAndDisposables(widget, index, attachment, hoverDelegate);
                        if (attachment.value instanceof URI) {
                            const readFile = await this.fileService.readFile(attachment.value);
                            if (store.isDisposed) {
                                return;
                            }
                            buffer = readFile.value.buffer;
                        }
                        else {
                            buffer = attachment.value;
                        }
                        this.createImageElements(buffer, widget, hoverElement);
                    }
                    catch (error) {
                        console.error('Error processing attachment:', error);
                    }
                    widget.style.position = 'relative';
                    store.add(this.hoverService.setupManagedHover(hoverDelegate, widget, hoverElement, { trapFocus: false }));
                    resolve();
                }));
            }
            else {
                const attachmentLabel = attachment.fullName ?? attachment.name;
                const withIcon = attachment.icon?.id ? `$(${attachment.icon.id}) ${attachmentLabel}` : attachmentLabel;
                label.setLabel(withIcon, undefined);
                ariaLabel = ( localize(7379, "Attached context, {0}", attachment.name));
                this.attachButtonAndDisposables(widget, index, attachment, hoverDelegate);
            }
            await Promise.all(attachmentInitPromises);
            if (store.isDisposed) {
                return;
            }
            if (file) {
                widget.style.cursor = 'pointer';
                store.add(addDisposableListener(widget, EventType.CLICK, (e) => {
                    EventHelper.stop(e, true);
                    const options = {
                        fromUserGesture: true
                    };
                    if (range) {
                        const textEditorOptions = {
                            selection: range
                        };
                        options.editorOptions = textEditorOptions;
                    }
                    this.openerService.open(file, options);
                }));
                store.add(addDisposableListener(widget, EventType.KEY_DOWN, (e) => {
                    const event = ( (new StandardKeyboardEvent(e)));
                    if (event.equals(3 ) || event.equals(10 )) {
                        EventHelper.stop(e, true);
                        const options = {
                            fromUserGesture: true
                        };
                        if (range) {
                            const textEditorOptions = {
                                selection: range
                            };
                            options.editorOptions = textEditorOptions;
                        }
                        this.openerService.open(file, options);
                    }
                }));
            }
            widget.tabIndex = 0;
            widget.ariaLabel = ariaLabel;
        }
        if (oldHeight !== container.offsetHeight) {
            this._onDidChangeHeight.fire();
        }
    }
    attachButtonAndDisposables(widget, index, attachment, hoverDelegate) {
        const store = this.attachedContextDisposables.value;
        if (!store) {
            return;
        }
        const clearButton = ( (new Button(widget, {
            supportIcons: true,
            hoverDelegate,
            title: ( localize(7380, "Remove from context")),
        })));
        if (index === Math.min(this._indexOfLastAttachedContextDeletedWithKeyboard, this.attachmentModel.size - 1)) {
            clearButton.focus();
        }
        store.add(clearButton);
        clearButton.icon = Codicon.close;
        const disp = Event.once(clearButton.onDidClick)((e) => {
            this._attachmentModel.delete(attachment.id);
            if (isKeyboardEvent(e)) {
                const event = ( (new StandardKeyboardEvent(e)));
                if (event.equals(3 ) || event.equals(10 )) {
                    this._indexOfLastAttachedContextDeletedWithKeyboard = index;
                }
            }
            if (this._attachmentModel.size === 0) {
                this.focus();
            }
            this._onDidChangeContext.fire({ removed: [attachment] });
        });
        store.add(disp);
    }
    createImageElements(buffer, widget, hoverElement) {
        const blob = ( (new Blob([buffer], { type: 'image/png' })));
        const url = URL.createObjectURL(blob);
        const pillImg = $$1('img.chat-attached-context-pill-image', { src: url, alt: '' });
        const pill = $$1('div.chat-attached-context-pill', {}, pillImg);
        const existingPill = widget.querySelector('.chat-attached-context-pill');
        if (existingPill) {
            existingPill.replaceWith(pill);
        }
        const hoverImage = $$1('img.chat-attached-context-image', { src: url, alt: '' });
        hoverElement.appendChild(hoverImage);
        hoverImage.onload = () => {
            URL.revokeObjectURL(url);
        };
    }
    async renderChatEditingSessionState(chatEditingSession, chatWidget) {
        setVisibility(Boolean(chatEditingSession), this.chatEditingSessionWidgetContainer);
        if (!chatEditingSession) {
            clearNode(this.chatEditingSessionWidgetContainer);
            this._chatEditsDisposables.clear();
            this._chatEditList = undefined;
            this._combinedChatEditWorkingSetEntries = [];
            this._chatEditsProgress?.dispose();
            return;
        }
        const currentChatEditingState = chatEditingSession.state.get();
        if (this._chatEditList && !chatWidget?.viewModel?.requestInProgress && ((currentChatEditingState === 2  || currentChatEditingState === 0) )) {
            this._chatEditsProgress?.stop();
        }
        const innerContainer = this.chatEditingSessionWidgetContainer.querySelector('.chat-editing-session-container.show-file-icons') ?? append(this.chatEditingSessionWidgetContainer, $('.chat-editing-session-container.show-file-icons'));
        const modifiedFiles = ( (new ResourceSet()));
        let entries = chatEditingSession?.entries.get().map((entry) => {
            modifiedFiles.add(entry.modifiedURI);
            return {
                reference: entry.modifiedURI,
                state: entry.state.get(),
                kind: 'reference',
            };
        }) ?? [];
        for (const attachment of this.attachmentModel.attachments) {
            if (attachment.isFile && URI.isUri(attachment.value) && !( (modifiedFiles.has(attachment.value)))) {
                entries.unshift({
                    reference: attachment.value,
                    state: 4 ,
                    kind: 'reference',
                });
                modifiedFiles.add(attachment.value);
            }
        }
        for (const [file, state] of chatEditingSession.workingSet.entries()) {
            if (!( (modifiedFiles.has(file)))) {
                entries.unshift({
                    reference: file,
                    state: state,
                    kind: 'reference',
                });
            }
        }
        entries.sort((a, b) => {
            if (a.kind === 'reference' && b.kind === 'reference') {
                if (a.state === b.state || a.state === undefined || b.state === undefined) {
                    return ( (a.reference.toString())).localeCompare(( (b.reference.toString())));
                }
                return a.state - b.state;
            }
            return 0;
        });
        let remainingFileEntriesBudget = this.chatEditingService.editingSessionFileLimit;
        const overviewRegion = innerContainer.querySelector('.chat-editing-session-overview') ?? append(innerContainer, $('.chat-editing-session-overview'));
        const overviewText = overviewRegion.querySelector('span') ?? append(overviewRegion, $('span'));
        overviewText.textContent = ( localize(7381, 'Working Set'));
        if (entries.length === 1) {
            overviewText.textContent += ' ' + ( localize(7382, '(1 file)'));
        }
        else if (entries.length >= remainingFileEntriesBudget) {
            const entriesToPreserve = [];
            const newEntries = [];
            for (let i = 0; i < entries.length; i += 1) {
                const entry = entries[i];
                const currentEntryUri = entry.kind === 'reference' && URI.isUri(entry.reference) ? entry.reference : undefined;
                if (this._combinedChatEditWorkingSetEntries.find((e) => ( (e.toString())) === currentEntryUri?.toString()) && remainingFileEntriesBudget > 0) {
                    entriesToPreserve.push(entry);
                    remainingFileEntriesBudget -= 1;
                }
                else {
                    newEntries.push(entry);
                }
            }
            const newEntriesThatFit = newEntries.slice(0, remainingFileEntriesBudget);
            entries = [...entriesToPreserve, ...newEntriesThatFit];
            remainingFileEntriesBudget -= newEntriesThatFit.length;
        }
        if (entries.length > 1) {
            overviewText.textContent += ' ' + ( localize(7383, '({0} files)', entries.length));
        }
        this._chatEditsActionsDisposables.clear();
        const actionsContainer = overviewRegion.querySelector('.chat-editing-session-actions') ?? append(overviewRegion, $('.chat-editing-session-actions'));
        this._chatEditsActionsDisposables.add(this.instantiationService.createInstance(MenuWorkbenchButtonBar, actionsContainer, MenuId.ChatEditingWidgetToolbar, {
            telemetrySource: this.options.menus.telemetrySource,
            menuOptions: {
                arg: { sessionId: chatEditingSession.chatSessionId },
            },
            buttonConfigProvider: (action) => {
                if (action.id === ChatEditingShowChangesAction.ID || action.id === ChatEditingSaveAllAction.ID) {
                    return { showIcon: true, showLabel: false, isSecondary: true };
                }
                return undefined;
            }
        }));
        if (!chatEditingSession) {
            return;
        }
        if (currentChatEditingState === 1  || chatWidget?.viewModel?.requestInProgress) {
            this._chatEditsProgress ??= ( (new ProgressBar(innerContainer)));
            this._chatEditsProgress?.infinite().show(500);
        }
        if (!this._chatEditList) {
            this._chatEditList = this._chatEditsListPool.get();
            const list = this._chatEditList.object;
            this._chatEditsDisposables.add(this._chatEditList);
            this._chatEditsDisposables.add(list.onDidFocus(() => {
                this._onDidFocus.fire();
            }));
            this._chatEditsDisposables.add(list.onDidOpen((e) => {
                if (e.element?.kind === 'reference' && URI.isUri(e.element.reference)) {
                    const modifiedFileUri = e.element.reference;
                    const entry = chatEditingSession.entries.get().find(entry => ( (entry.modifiedURI.toString())) === ( (modifiedFileUri.toString())));
                    const diffInfo = entry?.diffInfo.get();
                    const range = diffInfo?.changes.at(0)?.modified.toExclusiveRange();
                    this.editorService.openEditor({
                        resource: modifiedFileUri,
                        options: {
                            ...e.editorOptions,
                            selection: range,
                        }
                    }, e.sideBySide ? SIDE_GROUP : ACTIVE_GROUP);
                }
            }));
            this._chatEditsDisposables.add(addDisposableListener(list.getHTMLElement(), 'click', e => {
                if (!this.hasFocus()) {
                    this._onDidFocus.fire();
                }
            }, true));
            append(innerContainer, list.getHTMLElement());
        }
        const maxItemsShown = 6;
        const itemsShown = Math.min(entries.length, maxItemsShown);
        const height = itemsShown * 22;
        const list = this._chatEditList.object;
        list.layout(height);
        list.getHTMLElement().style.height = `${height}px`;
        list.splice(0, list.length, entries);
        this._combinedChatEditWorkingSetEntries = coalesce(( (entries.map(
            (e) => e.kind === 'reference' && URI.isUri(e.reference) ? e.reference : undefined
        ))));
        const addFilesElement = innerContainer.querySelector('.chat-editing-session-toolbar-actions') ?? append(innerContainer, $('.chat-editing-session-toolbar-actions'));
        const button = this._chatEditsActionsDisposables.add(( (new Button(addFilesElement, {
            supportIcons: true,
            secondary: true
        }))));
        button.enabled = remainingFileEntriesBudget > 0;
        button.label = ( localize(7384, '{0} Add Files...', '$(add)'));
        button.setTitle(button.enabled ? ( localize(7385, 'Add files to your working set')) : ( localize(
            7386,
            'You have reached the maximum number of files that can be added to the working set.'
        )));
        this._chatEditsActionsDisposables.add(button.onDidClick(() => {
            this.commandService.executeCommand('workbench.action.chat.editing.attachFiles', { widget: chatWidget });
        }));
        append(addFilesElement, button.element);
    }
    async renderFollowups(items, response) {
        if (!this.options.renderFollowups) {
            return;
        }
        this.followupsDisposables.clear();
        clearNode(this.followupsContainer);
        if (items && items.length > 0) {
            this.followupsDisposables.add(this.instantiationService.createInstance(ChatFollowups, this.followupsContainer, items, this.location, undefined, followup => this._onDidAcceptFollowup.fire({ followup, response })));
        }
        this._onDidChangeHeight.fire();
    }
    get contentHeight() {
        const data = this.getLayoutData();
        return data.followupsHeight + data.inputPartEditorHeight + data.inputPartVerticalPadding + data.inputEditorBorder + data.attachmentsHeight + data.toolbarsHeight + data.chatEditingStateHeight;
    }
    layout(height, width) {
        this.cachedDimensions = new Dimension(width, height);
        return this._layout(height, width);
    }
    _layout(height, width, allowRecurse = true) {
        const data = this.getLayoutData();
        const inputEditorHeight = Math.min(data.inputPartEditorHeight, height - data.followupsHeight - data.attachmentsHeight - data.inputPartVerticalPadding - data.toolbarsHeight);
        const followupsWidth = width - data.inputPartHorizontalPadding;
        this.followupsContainer.style.width = `${followupsWidth}px`;
        this._inputPartHeight = data.inputPartVerticalPadding + data.followupsHeight + inputEditorHeight + data.inputEditorBorder + data.attachmentsHeight + data.toolbarsHeight + data.chatEditingStateHeight;
        this._followupsHeight = data.followupsHeight;
        const initialEditorScrollWidth = this._inputEditor.getScrollWidth();
        const newEditorWidth = width - data.inputPartHorizontalPadding - data.editorBorder - data.inputPartHorizontalPaddingInside - data.toolbarsWidth - data.sideToolbarWidth;
        const newDimension = { width: newEditorWidth, height: inputEditorHeight };
        if (!this.previousInputEditorDimension || (this.previousInputEditorDimension.width !== newDimension.width || this.previousInputEditorDimension.height !== newDimension.height)) {
            this._inputEditor.layout(newDimension);
            this.previousInputEditorDimension = newDimension;
        }
        if (allowRecurse && initialEditorScrollWidth < 10) {
            return this._layout(height, width, false);
        }
    }
    getLayoutData() {
        const executeToolbarWidth = this.cachedExecuteToolbarWidth = this.executeToolbar.getItemsWidth();
        const inputToolbarWidth = this.cachedInputToolbarWidth = this.inputActionsToolbar.getItemsWidth();
        const executeToolbarPadding = (this.executeToolbar.getItemsLength() - 1) * 4;
        const inputToolbarPadding = this.inputActionsToolbar.getItemsLength() ? (this.inputActionsToolbar.getItemsLength() - 1) * 4 : 0;
        return {
            inputEditorBorder: 2,
            followupsHeight: this.followupsContainer.offsetHeight,
            inputPartEditorHeight: Math.min(this._inputEditor.getContentHeight(), this.inputEditorMaxHeight),
            inputPartHorizontalPadding: this.options.renderStyle === 'compact' ? 16 : 32,
            inputPartVerticalPadding: this.options.renderStyle === 'compact' ? 12 : 28,
            attachmentsHeight: this.attachedContextContainer.offsetHeight,
            editorBorder: 2,
            inputPartHorizontalPaddingInside: 12,
            toolbarsWidth: this.options.renderStyle === 'compact' ? executeToolbarWidth + executeToolbarPadding + inputToolbarWidth + inputToolbarPadding : 0,
            toolbarsHeight: this.options.renderStyle === 'compact' ? 0 : 22,
            chatEditingStateHeight: this.chatEditingSessionWidgetContainer.offsetHeight,
            sideToolbarWidth: this.inputSideToolbarContainer ? getTotalWidth(this.inputSideToolbarContainer) + 4  : 0,
        };
    }
    getViewState() {
        return this.getInputState();
    }
    saveState() {
        this.saveCurrentValue(this.getInputState());
        const inputHistory = [...this.history];
        this.historyService.saveHistory(this.location, inputHistory);
    }
};
ChatInputPart = ChatInputPart_1 = ( (__decorate([
    ( (__param(3, IChatWidgetHistoryService))),
    ( (__param(4, IModelService))),
    ( (__param(5, IInstantiationService))),
    ( (__param(6, IContextKeyService))),
    ( (__param(7, IConfigurationService))),
    ( (__param(8, IKeybindingService))),
    ( (__param(9, IAccessibilityService))),
    ( (__param(10, ILanguageModelsService))),
    ( (__param(11, ILogService))),
    ( (__param(12, IHoverService))),
    ( (__param(13, IFileService))),
    ( (__param(14, ICommandService))),
    ( (__param(15, IEditorService))),
    ( (__param(16, IOpenerService))),
    ( (__param(17, IChatEditingService)))
], ChatInputPart)));
const historyKeyFn = (entry) => JSON.stringify(entry);
function getLastPosition(model) {
    return { lineNumber: model.getLineCount(), column: model.getLineLength(model.getLineCount()) + 1 };
}
let ChatSubmitDropdownActionItem = class ChatSubmitDropdownActionItem extends DropdownWithPrimaryActionViewItem {
    constructor(action, dropdownAction, options, menuService, contextMenuService, chatAgentService, contextKeyService, keybindingService, notificationService, themeService, accessibilityService) {
        super(action, dropdownAction, [], '', {
            ...options,
            getKeyBinding: (action) => keybindingService.lookupKeybinding(action.id, contextKeyService)
        }, contextMenuService, keybindingService, notificationService, contextKeyService, themeService, accessibilityService);
        const menu = menuService.createMenu(MenuId.ChatExecuteSecondary, contextKeyService);
        const setActions = () => {
            const secondary = [];
            createAndFillInActionBarActions(menu, { shouldForwardArgs: true }, secondary);
            const secondaryAgent = chatAgentService.getSecondaryAgent();
            if (secondaryAgent) {
                secondary.forEach(a => {
                    if (a.id === ChatSubmitSecondaryAgentAction.ID) {
                        a.label = ( localize(7387, "Send to @{0}", secondaryAgent.name));
                    }
                    return a;
                });
            }
            this.update(dropdownAction, secondary);
        };
        setActions();
        this._register(menu.onDidChange(() => setActions()));
    }
};
ChatSubmitDropdownActionItem = ( (__decorate([
    ( (__param(3, IMenuService))),
    ( (__param(4, IContextMenuService))),
    ( (__param(5, IChatAgentService))),
    ( (__param(6, IContextKeyService))),
    ( (__param(7, IKeybindingService))),
    ( (__param(8, INotificationService))),
    ( (__param(9, IThemeService))),
    ( (__param(10, IAccessibilityService)))
], ChatSubmitDropdownActionItem)));
let ModelPickerActionViewItem = class ModelPickerActionViewItem extends MenuEntryActionViewItem {
    constructor(action, currentLanguageModel, delegate, options, keybindingService, notificationService, contextKeyService, themeService, contextMenuService, _languageModelsService, _accessibilityService) {
        super(action, options, keybindingService, notificationService, contextKeyService, themeService, contextMenuService, _accessibilityService);
        this.currentLanguageModel = currentLanguageModel;
        this.delegate = delegate;
        this._languageModelsService = _languageModelsService;
        this._register(delegate.onDidChangeModel(modelId => {
            this.currentLanguageModel = modelId;
            this.updateLabel();
        }));
    }
    async onClick(event) {
        this._openContextMenu();
    }
    render(container) {
        super.render(container);
        container.classList.add('chat-modelPicker-item');
        this._register(addDisposableListener(container, EventType.KEY_UP, e => {
            const event = ( (new StandardKeyboardEvent(e)));
            if (event.equals(3 ) || event.equals(10 )) {
                this._openContextMenu();
            }
        }));
    }
    updateLabel() {
        if (this.label) {
            const model = this._languageModelsService.lookupLanguageModel(this.currentLanguageModel);
            if (model) {
                reset(this.label, $$1('span.chat-model-label', undefined, model.name), ...renderLabelWithIcons(`$(chevron-down)`));
            }
        }
    }
    _openContextMenu() {
        const setLanguageModelAction = (id, modelMetadata) => {
            return {
                id,
                label: modelMetadata.name,
                tooltip: '',
                class: undefined,
                enabled: true,
                checked: id === this.currentLanguageModel,
                run: () => {
                    this.currentLanguageModel = id;
                    this.updateLabel();
                    this.delegate.setModel(id);
                }
            };
        };
        const models = ( (this._languageModelsService.getLanguageModelIds()
            .map(
            modelId => ({ id: modelId, model: this._languageModelsService.lookupLanguageModel(modelId) })
        )))
            .filter(entry => entry.model?.isUserSelectable);
        models.sort((a, b) => a.model.name.localeCompare(b.model.name));
        this._contextMenuService.showContextMenu({
            getAnchor: () => this.element,
            getActions: () => ( (models.map(entry => setLanguageModelAction(entry.id, entry.model)))),
        });
    }
};
ModelPickerActionViewItem = ( (__decorate([
    ( (__param(4, IKeybindingService))),
    ( (__param(5, INotificationService))),
    ( (__param(6, IContextKeyService))),
    ( (__param(7, IThemeService))),
    ( (__param(8, IContextMenuService))),
    ( (__param(9, ILanguageModelsService))),
    ( (__param(10, IAccessibilityService)))
], ModelPickerActionViewItem)));
const chatInputEditorContainerSelector = '.interactive-input-editor';
setupSimpleEditorSelectionStyling(chatInputEditorContainerSelector);

export { ChatInputPart };
